
package de.ivu.elect.business.email.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.email.entity.Email;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractEmailEdit {

  @Inject
  protected EmailDAO dao;

  @Inject
  protected EmailExtendedDAO extendedDao;

  public void delete(Email entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Email entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Email entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Email getAttachedEntity(Email entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Email getAttachedAndRefreshedEntity(Email entity) {
    return dao.refresh(entity);
  }
}
